<script setup lang="ts">
import { useReceiptStore } from '@/stores/receipt'
import { type Product, getImageUrl } from '@/types/Product'
import { computed, ref } from 'vue'
const receiptStore = useReceiptStore()
const popupVisible = ref(false)
const dialog = ref(false)
const showPopup = function () {
  popupVisible.value = true
}
const hidePopup = function () {
  popupVisible.value = false
}

const props = defineProps<{
  product: Product
}>()
const emit = defineEmits<{
  selectedProduct: [Product]
}>()

const clearSelection = () => {
  receiptStore.type = ''
  receiptStore.sweet = ''
  receiptStore.size = ''
}

const selected = function () {
  dialog.value = false
  console.log(receiptStore.sweet)
  console.log('ProductCard ' + props.product)
  console.log(props.product)
  console.log(receiptStore.receiptItems)
  emit('selectedProduct', props.product)
  clearSelection()
}

const openDialog = function () {
  if (props.product.category.id === 1) {
    dialog.value = true
  } else {
    emit('selectedProduct', props.product)
  }
}
</script>

<template>
  <v-sheet width="150" height="150" elevation="2" rounded @mouseenter="showPopup" @mouseleave="hidePopup"
    @click="openDialog">
    <v-img :src="getImageUrl(product)" height="170" cover></v-img>
    <div class="product-info">{{ product.name }} {{ product.price }} บาท</div>
  </v-sheet>

  <v-dialog v-model="dialog" persistent width="400" v-if="product.category.id === 1">
    <v-card>
      <v-card-title style="text-align: center;" class="mt-2">{{ product.name }}</v-card-title>
      <v-card-subtitle style="text-align: center;">฿ {{ product.price }}</v-card-subtitle>
      <v-card-text>
        <v-select :rules="[(v) => !!v || 'Field is required']" label="Size"
          :items="product.sizes ? product.sizes.map((size) => size.name) : []" v-model="receiptStore.size"
          variant="outlined" bg-color="#fff" clearable chips filled rounded></v-select>

        <v-select :rules="[(v) => !!v || 'Field is required']" label="Type" :items="product.subCategorys ? product.subCategorys.map((subCategory) => subCategory.name) : []
    " item-title="name" item-value="id" :return-object="true" v-model="receiptStore.type" variant="outlined"
          bg-color="#fff" clearable chips filled rounded></v-select>

        <v-select :rules="[(v) => !!v || 'Field is required']" label="Sweet"
          :items="['100%', '75%', '50%', '25%', '0%']" item-title="name" item-value="id" :return-object="true"
          v-model="receiptStore.sweet" variant="outlined" bg-color="#fff" clearable chips filled rounded></v-select>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn variant="text" @click="dialog = false"> Cancel </v-btn>
        <v-btn variant="text" @click="selected"> OK </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<style scoped>
/* เพิ่ม border ใน v-sheet */
.v-img,
.v-sheet {
  border-radius: 15%;
}

.product-info {
  text-align: center;
  font-family: 'Times New Roman', Times, serif;
  font-size: 16px;
  margin-top: 6px;
  color: #412f26;
}

.v-card {
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}
</style>
